;******************************************************************************
;                                                                             *
; Copyright (C) 2012 Sergio García-Cuevas González.                           *
;                                                                             *
; This program is free software; you can redistribute it and/or modify        *
; it under the terms of the GNU General Public License as published by        *
; the Free Software Foundation; either version 3 of the License, or           *
; (at your option) any later version.                                         *
;                                                                             *
; This program is distributed in the hope that it will be useful,             *
; but WITHOUT ANY WARRANTY; without even the implied warranty of              *
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
; GNU General Public License for more details.                                *
;                                                                             *
; You should have received a copy of the GNU General Public License           *
; along with this program.  If not, see <http://www.gnu.org/licenses/>.       *
;                                                                             *
;******************************************************************************

        list      p=12f629
        #include <p12f629.inc>
        #include "asm/config.inc"

        GLOBAL  apply_command
        EXTERN  duty,new_cmd,sGPIO,state

APPLY_COMMAND   CODE
; Apply the current command.
; 
; Uses:
;   - duty
;   - new_cmd
;   - GPIO
;   - sGPIO
;   - state
apply_command
        MOVLW   stop_gpio            ; Suppose we want to stop.
        BTFSC   new_cmd,forward_cmd  ; If we want to go forward.
        MOVLW   forward_gpio
        BTFSC   new_cmd,backward_cmd ; If we want to go backward.
        MOVLW   backward_gpio
        BTFSC   new_cmd,left_cmd     ; If we want to turn left.
        MOVLW   left_gpio
        BTFSC   new_cmd,right_cmd    ; If we want to turn right.
        MOVLW   right_gpio
        BTFSC   new_cmd,horn_cmd     ; If we want to use the horn.
        MOVLW   horn_gpio
        BTFSC   new_cmd,light_cmd    ; If we want to turn on the light.
        MOVLW   light_gpio
        MOVWF   sGPIO                ; Update sGPIO.
        MOVF    sGPIO,W              ; Commit the changes into GPIO.
        MOVWF   GPIO
        BCF     state,motors_on      ; Assume motors are off.
        BTFSC   sGPIO,motors_pin     ; If motor are on
        BSF     state,motors_on      ; then flag them as such.
        MOVLW   duty_on              ; Initialise the duty-cycle counter.
        MOVWF   duty
        RETURN

        END
