;******************************************************************************
;                                                                             *
; Copyright (C) 2012 Sergio García-Cuevas González.                           *
;                                                                             *
; This program is free software; you can redistribute it and/or modify        *
; it under the terms of the GNU General Public License as published by        *
; the Free Software Foundation; either version 3 of the License, or           *
; (at your option) any later version.                                         *
;                                                                             *
; This program is distributed in the hope that it will be useful,             *
; but WITHOUT ANY WARRANTY; without even the implied warranty of              *
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
; GNU General Public License for more details.                                *
;                                                                             *
; You should have received a copy of the GNU General Public License           *
; along with this program.  If not, see <http://www.gnu.org/licenses/>.       *
;                                                                             *
;******************************************************************************

        list      p=12f629
        #include <p12f629.inc>
        #include "asm/config.inc"

        GLOBAL  stable_p
        EXTERN  new_cmd,old_cmd,stable,state

STABLE_P        CODE
; Check the current command reading for stability.
; 
; Uses:
;   - new_cmd
;   - old_cmd
;   - state
stable_p
        BCF     state,got_cmd   ; Assume the reading is not stable.
        MOVF    new_cmd,W       ; Compare the new reading
        XORWF   old_cmd,W       ; against the old reading.
        BTFSC   STATUS,Z        ; If the new reading == the old reading
        GOTO    match           ; then update the stability count down
        MOVLW   countdown       ; else reset the counter
        MOVWF   stable
        RETURN                  ; and return.
match
        DECFSZ  stable,F        ; We got a match.  Decrease the counter.
        RETURN                  ; If count down is not zero, just return.
        BSF     state,got_cmd   ; Else we have a command.
        RETURN                  ; Return with the good news.

        END
